var m_button;
var m_inited = false;
var m_prefs;

function proxybutton_switchProxy() {

    var nCurProxyType = m_prefs.getIntPref("network.proxy.type");
    if (nCurProxyType == 1) {
        proxybutton_setDirect();
    } else if (nCurProxyType == 0) {
        proxybutton_setManual();
    }
}

function proxybutton_init() {
    if (!m_inited) {
       m_button = document.getElementById("proxybutton-button");
       m_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
       m_inited = true;

       var rObserver = {
          observe : function(subject, topic, data) { proxybutton_setButtonFromPreference(); }
       };
       var rPrefs  = Components.classes["@mozilla.org/preferences-service;1"].createInstance(Components.interfaces.nsIPrefBranchInternal);
       rPrefs.addObserver("network.proxy", rObserver, false);
    }
    proxybutton_setButtonFromPreference();
}

function proxybutton_setButtonFromPreference() {
    var nCurProxyType = m_prefs.getIntPref("network.proxy.type");
    if (nCurProxyType == 0) {
        proxybutton_setDirect();
    } else if (nCurProxyType == 1) {
        proxybutton_setManual();
    }

}

function proxybutton_setDirect() {
    m_prefs.setIntPref("network.proxy.type", 0);
    proxybutton_changeImage(0);
}

function proxybutton_changeImage(nToType) {
    var sPrefix;

    if (document.getElementById("navigator-toolbox").getAttribute("iconsize")=='small') {
        sPrefix = 'small';
    } else {
        sPrefix = 'big';
    }

    if (nToType==0) {
        // m_button.setAttribute('image', 'chrome://proxybutton/skin/'+sPrefix+'button.png');
        m_button.setAttribute('pbstatus', 'off');
        m_button.setAttribute('tooltiptext', 'Turn proxy on');
    } else {
//        m_button.setAttribute('image', 'chrome://proxybutton/skin/'+sPrefix+'button_gr.png');
        m_button.setAttribute('pbstatus', 'on');
        m_button.setAttribute('tooltiptext', 'Turn proxy off');
    }
}

function proxybutton_setManual() {
    m_prefs.setIntPref("network.proxy.type", 1);
    proxybutton_changeImage(1);
}